### org.jfree.layouting.normalizer.displaymodel

# Interface ModelBuilder

All Superinterfaces:
  StatefullComponent

Known Implementing Classes:
  EmptyModelBuilder, FastDisplayModelBuilder

`public interface ModelBuilder`
`extends StatefullComponent`

The model builder is the second stage in the layout process. The builder receives events from the Normalizer and builds a normalized displayable logical model. Although still working on a logical document model, this model is already bound to the constraints of the underlying renderer. Each generated element has information on which logical page it will be rendered (by looking at the page style name); depending on the output target, it might even know the physical page already (including the page number). (The PageInformation is initiated by the Normalizer.) The ModelBuilder is responsible to manage the moved content.

Author:
  Thomas Morgner

  ## Method Summary

  `void`

  `addContent(ContentToken content)`

  `void`

  `endDocument()`

  `void`

  `endElement()`

  `Renderer`

  `getRenderer()`

  `void`

  `handlePageBreak(PageContext pageContext)`

  `void`

  `startDocument(PageContext pageContext)`

  `void`

  `startElement(LayoutContext layoutContext)`

  ### Methods inherited from interface org.jfree.layouting.StatefullComponent

  `saveState`

## Method Details

### addContent

    public void addContent(ContentToken content)
                throws NormalizationException

### endDocument

    public void endDocument()
                throws NormalizationException

### endElement

    public void endElement()
                throws NormalizationException

### getRenderer

    public Renderer getRenderer()

### handlePageBreak

    public void handlePageBreak(PageContext pageContext)
                throws NormalizationException

### startDocument

    public void startDocument(PageContext pageContext)
                throws NormalizationException

### startElement

    public void startElement(LayoutContext layoutContext)
                throws NormalizationException,
                       IOException